/*
** CONEXIONES.C
**
**
** (c) 1.997-99 Jesus Cea Avion
** jcea@argo.es
** http://www.argo.es/~jcea/
** http://www.argo.es/~jcea/artic/radius02.htm
**
** Lea las condiciones de uso y distribucion
** en el fichero "COPYING".
**
**
** 20/May/97 Versin 1.0
**           Primera versin de este CGI.
**
** 20/May/97 Versin 1.1
**           Permite monitorizar las conexiones de cualquier usuario
**           sin ms que escribir al final un ?clave*login (* es comodn)
**
** 23/Jun/97 Versin 1.2
**           Pone la misma apariencia tpica que el resto de pginas de ARGO.
**
** 26/Jun/97 Versin 1.3
**           Aadidos CSIVs de Bilbao y Sevilla.
**
** 19/Sep/97 Versin 1.5
**           Aadido trfico acumulado Entrada/Salida, en paquetes y bytes.
**           Las centrales analgicas se identifican como tales.
**           Proporciona la IP actual de un usuario conectado.
**           Proporciona el LOGIN de una IP determinada conectada ahora.
**
** 19/Sep/97 Versin 1.51
**           Los datos de los CSIVs se leen en orden, sin comprobar las
**           fechas. Por tanto, si un usuario entra un da por un CSIV
**           ledo ms tarde que su CSIV normal, aparecer siempre como
**           STOP. Hay que contrastar con las fechas de los registros.
**           Como el escaneo se realiza sobre un nico mes, no es preciso
**           Intercambiar MES y DIA en el campo FECHA de cada REGISTRO (y ao).
**
** 10/Dic/97 Versin 1.53
**           Se incluye un mensaje para aquellos usuarios propios que
**           entran a travs de una red externa.
**           Si pongo clave correcta, me deja acceder AUNQUE no est en la red ARGO.
**           La informacin sobre IP actual se est disponible en la parte
**           inferior de la pgina *AUNQUE* no se indique clave de acceso.
**
** 11/Dic/97 Versin 2.0
**           Indica la causa de la ltima desconexin.
**           ATENCION: A partir de ahora este script es llamado tambin
**           mensualmente por un proceso *fuera* del servidor, para sacar las
**           estadsticas de cada usuario mes a mes. Para que ello sea posible
**           se permite llamar directamente al CGI desde la linea de comando,
**           y marca el principio y el final de la zona interesante con un
**           "<!mensual>" en cada linea para poder reconocerlo bien con un
**           simple awk.
**           Las estad&iacute;sticas antiguas se leen haciendo que el
**           ultimo carcter del "query-string" sea un "*".
**           Se aade un enlace a las estadsticas antiguas en la propia pgina
**           Se aade "91307" a los nmeros "de prueba".
**
** 16/Ene/98 Versin 2.1
**           Aadida "Content-Type: text/html".
**
** 06/May/98 Versin 2.2
**           Desde el 4 de Abril infova manda el "9" inicial.
**
** 19/May/98 Versin 2.3
**           Migracin de 194.235.99.* a 195.53.30.*
**
** 28/May/98 Version 2.4
**           Indica la fecha de la ultima conexion.
**
** 28/Sep/98 Version 2.5
**           Debido a que el RADIUS parece grabar algunos registros duplicados
**           en el "accounting", lo verifica y los descarta si es necesario.
**           Anade nuevos numeros en el mensaje de "numeros excluidos" para las
**           llamadas realizadas por nosotros para comprobar el sistema.
**
** 30/Sep/98 Version 2.52
**           Aunque la mayoria de los datos son correctos, la causa de la ultima
**           conexion se leia del ultimo registro leido, no de la ultima conexion
**           efectuada. No coinciden si el usuario tiene entradas por diferentes
**           CSIVs.
**           Anadida la causa de desconexion 20
**
** 13/Oct/98 Version 2.6
**           Los datos de configuracion especificos de cada ISP se especifican
**           a traves de variables "extern": clase C, clave, ISP, CSIVs, archivo historico.
**           Todas las URLs se ponen absolutas.
**           Anadido mensaje exigido por la licencia.
**
** 15/Oct/98 Version 2.7
**           Ya no es necesario hacer un include directo de "lee_log.c", ya que
**           todo se ha centralizado en el "make" y en las librerias y objetos.
**
** 20/Oct/98 El uso de una libreria de cadenas propia mejora el rendimiento.
**
** 26/Oct/98 El programa y ano genera un CORE si la entrada CLI es incorrecta.
**
** 27/Oct/98 El programa funciona aunque no se usen "@" en el username.
**           El array de accounting define el sufijo a anadir y las
**           rutinas a usar para acceder a cada fichero.
**
** 18/Nov/98 La linea de comandos permite limitar el tiempo a considerar
**           anadiendo parametros en formato yyyymmddhhmm
**
** 20/Nov/98 Anadidos los marcos horarios por defecto
**           a la hora de leer un fichero de log.
**
** 23/Nov/98 Todos los tiempos en los registros son segundos.
**           Anadidas las nuevas causas de desconexion.
**
** 25/Nov/98 La generacion de la salida HTML se
**           ha movido a un modulo externo.
**
** 01/Dic/98 Corregido un problema de filtrado por fechas
**           cuando en el log hay entradas que estan fuera
**           del intervalo temporal a considerar.
**
** 17/Dic/98 Soporte para un modulo generico de salida.
**
** 30/Dic/98 Se continua la migracion al modulo
**           generico de salida.
**
** 04/Dic/98 Se cambian de sitio las rutinas "str2tiempo"
**           y "tiempo2str".
*/

#include "conexiones.h"
#include "version.h"
#include "config.h"
#include <stdlib.h>
#include <stdio.h>
#include <pwd.h>
#include <ctype.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "util.h"

#undef strchr(a,b)
#define strchr(a,b) strchr_jcea(a,b)
#undef strcmp(a,b)
#define strcmp(a,b) strcmp_jcea(a,b)

static t_salida_conexiones val;

static char ip_log[CAMPO_LONG];
static long fecha,fecha2;

/****
static time_t convierte_tiempo_radius(char *tiempo)
{
struct tm tm;

  strptime(tiempo,"%d-%m-%Y %H:%M:%S",&tm);
  return mktime(&tm);
}
*****/

static void analiza_conexion(char *f_detalle,char *nombre,t_log *log)
{
registro_log reg;
log_estado estado;
t_caller_id *numero;
char elimina_duplicado[CAMPO_LONG];
  
  elimina_duplicado[0]='\0';

  log->abre_log(f_detalle,nombre);
  while (!0) {
    estado=log->lee_registro(&reg);
    if(estado!=LOG_OK) break;
    fecha2=reg.tiempo;

    if(tiempo_inicial>fecha2) continue;
    if(tiempo_final<fecha2-reg.duracion) continue;

    if(strcmp(reg.nombre,nombre)) continue;  /* Nos lo saltamos */
    if(fecha2>fecha) {
      fecha=fecha2;
      strcpy(ip_log,reg.ip);  /* IP de esta conexin */
    }

    if(reg.tipo!=STOP) continue;  /* Nos lo saltamos */

    if(fecha2>=fecha) {
      *ip_log='\0';  /* Este IF es por esta LINEA */
    }

    if(!strcmp(reg.sesion_id,elimina_duplicado)) continue;
    strcpy(elimina_duplicado,reg.sesion_id);

    if(fecha2>val.ultima_conexion) {
      val.ultima_conexion=fecha2;
      val.ultimo_tiempo=reg.duracion;
      val.causa_desconexion=reg.causa;
    }

    val.num_conexiones++;
    val.tiempo+=reg.duracion;
    val.bytes_tx+=reg.bytes_tx;
    val.bytes_rx+=reg.bytes_rx;
    val.paquetes_tx+=reg.paquetes_tx;
    val.paquetes_rx+=reg.paquetes_rx;
    numero=val.numero;
    while(numero!=NULL) {
      if(!strcmp(numero->numero,reg.caller_id)) {
        numero->num_conexiones++;
        numero->tiempo+=reg.duracion;
        break;  /* Ya lo tenemos */
      }
      /* No lo ha encontrado an */
      numero=numero->siguiente;
    }
    if(numero!=NULL) continue;  /* Ya lo tenemos */
    numero=val.numero;  /* Lo aade */
    val.numero=malloc(sizeof(t_caller_id));
    strcpy(val.numero->numero,reg.caller_id);
    val.numero->siguiente=numero;
    val.numero->num_conexiones=1;
    val.numero->tiempo=reg.duracion;
  }
  log->cierra_log();
}

static registro_log buscar_ip(char *f_detalle,char *ip,t_log *log)
{
registro_log reg,reg2;
log_estado estado;

  reg.tipo=STOP;
  log->abre_log(f_detalle,"");
  while (!0) {
    estado=log->lee_registro(&reg2);
    if(estado!=LOG_OK) break;
    if(strcmp(reg2.ip,ip)) continue;  /* Nos lo saltamos */
    fecha2=reg2.tiempo;
    if(fecha2<fecha) continue;/* Nos lo saltamos */
    fecha=fecha2;
    reg=reg2;
  }
  log->cierra_log();
  return reg;
}

int main_conexiones(int argc,char *argv[],char *env[])
{
char *ip;
char *string;
char *clave=NULL;
char *p;
char **p2;
int clave_flag=0;
int contador;
time_t tiempo=time(NULL);
struct stat stat_file;
char buf[1024];
t_salida_cabecera cabecera;

  fecha=0;
  val.ultima_conexion=0;
  val.ultimo_tiempo=0;
  val.anteriores_flag=0;
  val.login=NULL;

  string=getenv("QUERY_STRING");
  if((string!=NULL)&&(!strncmp(string,CLAVE,strlen(CLAVE)))&&
    (strlen(string)>strlen(CLAVE)+1)&&
    (strlen(string)<CAMPO_LONG)) { /* El ltimo check evita exploits */
    clave_flag=!0;
    clave=string+strlen(CLAVE)+1;  /* Nos saltamos el separador */
  }
  if((string!=NULL)&&(strlen(string))&&(*(string+strlen(string)-1)=='*'))
    val.anteriores_flag=!0;
  
  ip=getenv("REMOTE_ADDR");
  cabecera.ip=ip;
  if(ip==NULL)
  {  /* Llamada directa */
    if(argc<2) return 0; /* Si llamada directa -> al menos un parametro */
    clave_flag=!0;
    clave=argv[1];
  }
  
  cabecera.dns_inverso=getenv("REMOTE_HOST");

  cabecera.navegador=getenv("HTTP_USER_AGENT");

  /*
  ** El hack funciona desde cualquier red.
  ** Las llamadas directas SIEMPRE tienen que poner la clave.
  */
  for(contador=0;(ip!=NULL)&&(RED[contador]!=NULL);contador++) {
    if(!strncmp(ip,RED[contador],strlen(RED[contador]))) {
      contador=-1;
      break;
    }
  }

  /*
  ** Otro hack para poder asignar usuarios fijos a
  ** IPs fijas sin necesidad de darlos de alta en dos
  ** estructuras diferentes (en IP_USUARIO y en RED).
  */
  if(contador>=0) for(contador=0;(ip!=NULL)&&(IP_USUARIO[contador].ip!=NULL);contador++) {
    if(!strcmp(ip,IP_USUARIO[contador].ip)) {
      contador=-1;
      break;
    }
  }

  if((clave_flag)||(contador<0)) {
  registro_log reg;
  
  /* Busca el propietario de esta conexin */
  
    if(clave_flag) {  /* Pregunta genrica */
      if(val.anteriores_flag) {  /* meses previos */
      char *p;

        *(clave+strlen(clave)-1)='\0';
        p=clave;
        while(*p) {  /* usuario vlido */
          if((!isalnum(*p))&&(*p!='_')&&(*p!='-')&&(*p!='.')) {
            exit(-1);
          }
          p++;
        }
        val.login=clave;

        strcpy(buf,D_HISTORICO);
        strcat(buf,clave);
        stat(buf,&stat_file);
        tiempo=stat_file.st_ctime;
        if(tiempo<libreria_timestamp()) tiempo=libreria_timestamp();
        
        SALIDA.salida_cabecera(&cabecera,tiempo,dia1_siguiente_mes(tiempo));
        SALIDA.salida_conexiones(&val);
        SALIDA.salida_final();
        exit(0);
      }
      reg.tipo=START;
      strcpy(reg.nombre,clave);

    /*
    ** Esto es para poder tener nombres de usuario que
    ** empiezan con numeros.
    */
      if((*clave>='0')&&(*clave<='9')) {  /* Busca IP */
        for(contador=0;(ip!=NULL)&&(RED[contador]!=NULL);contador++) {
          if(!strncmp(clave,RED[contador],strlen(RED[contador]))) {
            contador=-1;
            break;
          }
        }

        if(contador>=0) for(contador=0;(ip!=NULL)&&(IP_USUARIO[contador].ip!=NULL);contador++) {
          if(!strcmp(clave,IP_USUARIO[contador].ip)) {
            contador=-1;
            break;
          }
        }
        if(contador<0) { /* Es una IP, no un usuario numerico */
          ip=clave;
          contador=0;
          do {
            reg=buscar_ip(accounting[contador].path,ip,accounting[contador].log);
            contador++;
          } while((reg.tipo==STOP)&&(accounting[contador].path!=NULL));
        }
      }
    } else { /* Pregunta de un usuario */
      contador=0;
      do {
        reg=buscar_ip(accounting[contador].path,ip,accounting[contador].log);
        contador++;
      } while((reg.tipo==STOP)&&(accounting[contador].path!=NULL));
      clave=reg.nombre;
    }

  /*
  ** Hack para poder asignar un usuario fijo a una IP fija
  */

    for(contador=0;(ip!=NULL)&&(IP_USUARIO[contador].ip!=NULL);contador++) {
      if(!strcmp(ip,IP_USUARIO[contador].ip)) {
        reg.tipo=START;
        strcpy(reg.nombre,IP_USUARIO[contador].usuario);
        break;
      }
    }
  
    if(reg.tipo!=STOP) {  /* Lo tenemos */
    struct passwd *pwd;
    
      p=strchr(reg.nombre,'@');
      if(p!=NULL) *p='\0';
      val.login=reg.nombre;
      if(val.anteriores_flag) {
        strcpy(buf,D_HISTORICO);
        strcat(buf,clave);
        stat(buf,&stat_file);
        tiempo=stat_file.st_ctime;
        if(tiempo<libreria_timestamp()) tiempo=libreria_timestamp();
 
        SALIDA.salida_cabecera(&cabecera,tiempo,dia1_siguiente_mes(tiempo));
        SALIDA.salida_conexiones(&val);
        SALIDA.salida_final();
        exit(0);
      }
#ifdef NOPASSWD
      pwd=NULL;
#else
      pwd=getpwnam(reg.nombre);
#endif
      if(pwd!=NULL) {
        val.nombre=pwd->pw_gecos;
      } else val.nombre="(An&oacute;nimo; cuenta corporativa)";

      if(p!=NULL) *p='@';
      val.num_conexiones=val.tiempo=0;
      val.bytes_tx=val.bytes_rx=0;
      val.paquetes_tx=val.paquetes_rx=0;
      val.numero=NULL;

   /* IP del usuario, si est conectado ahora */
     *ip_log='\0';
  
      if(p==NULL) p=reg.nombre+strlen(reg.nombre);
      fecha=0; /* Por si antes se llamo a buscar_ip */
      for(contador=0;accounting[contador].path!=NULL;contador++) {
        p2=accounting[contador].AT_ISP;
        while ((p2!=NULL) && (*p2!=NULL)) {
          strcpy(p,*p2);
          p2++;
          analiza_conexion(accounting[contador].path,reg.nombre,accounting[contador].log);
        } 
      }

      *p='\0';

      val.ip=ip_log;
      val.fecha=fecha;
      val.query_string=string;

    }
    if(val.ip==NULL) val.fecha=val.ultima_conexion;
    if(!val.fecha) val.fecha=tiempo;

    SALIDA.salida_cabecera(&cabecera,
      val.fecha<libreria_timestamp() ? libreria_timestamp() :
                                       val.fecha
      ,tiempo);
    SALIDA.salida_conexiones(&val);
    SALIDA.salida_final();
    exit(0);
  } 
  SALIDA.salida_cabecera(&cabecera,tiempo,tiempo);
  SALIDA.salida_conexiones(NULL);
  SALIDA.salida_final();
  exit(0);
}

