/*
** CONFIG.H
**
** Configuracion.
**
**
** (c) 1.997-99 Jesus Cea Avion
** jcea@argo.es
** http://www.argo.es/~jcea/
** http://www.argo.es/~jcea/artic/radius02.htm
**
** Lea las condiciones de uso y distribucion
** en el fichero "COPYING".
**
**
** 14/Dic/98 Version 1.0
**           Este fichero permite tener en un unico
**           lugar, pero fuera de la libreria, la
**           la configuracion necesaria para todos
**           los programas que usan la libreria en si.
**
** 08/Ene/99 Se mueven gran cantidad de definiciones
**           de conexiones.h a este modulo.
*/

#ifndef CONFIG_H
#define CONFIG_H

#include <time.h>
#include "salida.h"

extern char *RED[];
extern char *CLAVE;
extern char *D_HISTORICO;
extern t_salida SALIDA;

typedef struct {
  char *ip;
  char *usuario;
} t_ip_usuario;

extern t_ip_usuario IP_USUARIO[];

typedef struct {
  void (*abre_log) (char *f_detalle, char *usuario);
  void (*cierra_log) (void);
  log_estado (*lee_registro) (registro_log *registro);
} t_log;

typedef struct {
  char *path;
  char **AT_ISP;
  t_log *log;
} t_accounting;

extern t_accounting accounting[];

extern time_t tiempo_inicial;
extern time_t tiempo_final;

time_t str2tiempo(char *tiempo);
void tiempo2str(char *buf,time_t tiempo);
time_t dia1_este_mes(time_t tiempo);
time_t dia1_siguiente_mes(time_t tiempo);
time_t clipping_mensual(void);
void activa_clipping_mensual(int argc,char *argv[]);

#endif

