/*
** SALIDA.H
**
** Modulo generico de salida
**
**
** (c) 1.997-99 Jesus Cea Avion
** jcea@argo.es
** http://www.argo.es/~jcea/
** http://www.argo.es/~jcea/artic/radius02.htm
**
** Lea las condiciones de uso y distribucion
** en el fichero "COPYING".
**
**
** 17/Dic/98 Primera version de este modulo.
**
** 30/Dic/98 Se continua la migracion al modulo
**           generico de salida.
*/

#ifndef SALIDA_H
#define SALIDA_H

#include <time.h>
#include "lee_log.h"

typedef struct {
  char *ip;
  char *dns_inverso;
  char *navegador;
} t_salida_cabecera;

typedef struct {
  char numero[CAMPO_LONG];
  long num_conexiones;
  long tiempo;
/*
** Deberia ser un puntero a t_caller_id,
** pero en un typedef no nos deja.
*/
  void *siguiente;
} t_caller_id;

typedef struct {
  char *login;
  char *nombre;
  long num_conexiones;
  time_t tiempo;
  t_caller_id *numero;
  long long bytes_tx;
  long long bytes_rx;
  long long paquetes_tx;
  long long paquetes_rx;
  long ultima_conexion;
  long ultimo_tiempo;
  int causa_desconexion;
  char *ip;     /* De la conexion actual */
  time_t fecha; /* De la conexion actual */
  char *query_string;  /* Peticion URL */
  int anteriores_flag;  /* Solicitamos el archivo historico */
} t_salida_conexiones;

void salida_cabecera(t_salida_cabecera *datos);
void salida_conexiones(t_salida_conexiones *datos);

typedef struct {
  void (*salida_cabecera) (t_salida_cabecera *datos,time_t fecha,time_t expiracion);
  void (*salida_conexiones) (t_salida_conexiones *datos);
  void (*salida_final) (void);
} t_salida;

#endif

