/*
** SALIDA_HTML.C
**
** Genera la pagina web de salida
**
**
** (c) 1.997-99 Jesus Cea Avion
** jcea@argo.es
** http://www.argo.es/~jcea/
** http://www.argo.es/~jcea/artic/radius02.htm
**
** Lea las condiciones de uso y distribucion
** en el fichero "COPYING".
**
**
** 25/Nov/98 Primera version de este modulo.
**
** 01/Dic/98 Corregidos el tema de acentos.
**
** 17/Dic/98 Soporte para modulo de salida generico.
**
** 30/Dic/98 Se continua la migracion al modulo
**           generico de salida.
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include "salida_html.h"
#include "version.h"

#include "config.h"

static void envia_post(void)
{
  printf("<P><HR ALIGN=CENTER SIZE=1 WIDTH=75%%>\n"
         "<UL><LI><P><A HREF=http://www.argo.es/argo.html><I>P&aacute;gina de Entrada</I></A>\n"
         "<LI><P><A HREF=http://www.argo.es/ayudas><I>Ayuda</I></A>\n"
         "</UL><!--Pie de p\141gina-->\n"
         "<HR ALIGN=CENTER SIZE=1 WIDTH=75%%>\n"
         "<UL><LI><FONT SIZE=-1 FACE=Arial>Para consultas o correcciones sobre "
         "estas p&aacute;ginas, dir&iacute;jase a: "
         "<A HREF=mailto:webmaster@argo.es>webmaster@argo.es</A></FONT>\n"
         "<LI><FONT SIZE=-1 FACE=Arial>Para informaci&oacute;n general sobre "
         "ARGO Redes y Servicios,dir&iacute;jase a: "
         "<A HREF=mailto:argo@argo.es>argo@argo.es</A></FONT>\n"
         "</UL><CENTER><A HREF=http://www.argo.es/informacion.html>"
         "<IMG SRC=http://www.argo.es/images/argologo2.gif WIDTH=115 HEIGHT=68 BORDER=0 "
         "ALT=\"Logo ARGO\" ALIGN=MIDDLE><FONT FACE=\"Times New Roman\""
         "COLOR=Blue SIZE=-1>\n"
         "<BR>Redes y Servicios Telem&aacute;ticos</A>&nbsp;<SUP>&copy;"
         "</SUP></FONT></CENTER>\n"
         "<p align=right><font size=-2>");

  printf("%s",version_html());
  printf("</font>"
         "</CENTER>"
         "</td></tr></table>"
         "</BODY></HTML>\n"
         );
}

void salida_final_html(void)
{
        printf("<font size=-1><ul><li>Si el n&uacute;mero de paquetes transmitidos "
        "es muy superior al n&uacute;mero de paquetes recibidos, es muy "
        "posible que est&eacute; exportando capacidades NETBIOS sobre TCP/IP. "
        "Al margen de los problemas de seguridad asociados, dichos paquetes "
        "consumen ancho de banda, y los usuarios deber&iacute;an tomar "
        "<a href=\"http://www.argo.es/~jcea/artic/netbios.htm\">las "
        "medidas oportunas</a>\n");

/*
        "<li>Por cuestiones de privacidad, "
        "s&oacute;lo se listan los cinco primeros d&iacute;gitos del "
        "n&uacute;mero nacional del llamante\n"
*/

        printf("<li>Los n&uacute;meros <b>\"91372\"</b>, <b>\"91307\"</b> y <b>\"91411\"</b> "
        "pueden corresponder a pruebas de "
        "funcionamiento por parte de ARGO, por lo que su aparici&oacute;n "
        "es relativamente normal\n"
        "<li>Si detecta llamadas desde n&uacute;meros cuya identidad "
        "desconoce, p&oacute;ngase en contacto enseguida con ARGO\n"
        "</ul>"
        "</font>\n");

  envia_post();
}

static void lista_antiguo(char *usuario)
{
int f;
char buf[1024];

  strcpy(buf,D_HISTORICO);
  strcat(buf,usuario);
  f=open(buf,O_RDONLY);
  if(f==-1) {
    printf("<center><h1>No se encuentra informaci&oacute;n previa \n"
      "<br>sobre ese usuario</h1>\n"
      "Ello es normal si se trata de un usuario con\n"
      "<br>una antig&#252;edad inferior a un mes\n"
      "</center>");
  } else {
    while(read(f,buf,1)==1) printf("%c",buf[0]);
    close(f);
  }
}

static char *salida_valida(char *texto)
{
  if(texto==NULL) return "Informaci&oacute;n no disponible";
  return texto;
}

void salida_tiempo(char *cabecera,time_t tiempo)
{
struct tm *tm;
char *p;

  tm=gmtime(&tiempo);
  p=asctime(tm);  
  *strchr(p,'\n')='\0';
  printf("%s: %s GMT\n",cabecera,p);
}

void salida_cabecera_html(t_salida_cabecera *datos,time_t fecha,time_t expiracion)
{
  printf("Cache-Control: private\n");
  salida_tiempo("Last-Modified",fecha);
  salida_tiempo("Expires",expiracion);
  printf("Content-Type: text/html\n\n");  /* Necesidad del protocolo */
  printf("<html><head><title>Informaci&oacute;n de Conexiones</title></head>\n"
         "<body text=Black bgcolor=White link=blue vlink=purple alink=Red "
         "background=http://www.argo.es/images/backgrd3.gif>\n"
         "<center><table width=80%%><tr><td>\n"
         "<center><h1>Informaci&oacute;n de Conexiones</h1>\n"
         "<i>Revisi&oacute;n ");

  printf("%s. %s",version(),version_fecha());

  printf("</i></center>\n"
         "<p><br><center><table width=100%%>\n"
         "<tr><td width=49%% valign=top align=right>Su direcci&oacute;n IP<p>\n"
         "Su nombre de dominio<p>\n"
         "Navegador que emplea<p>\n"
         "</td><td width=2%%></td><td valign=top>\n"
         );

  printf("%s<p>%s<p>%s<p>",
         salida_valida(datos->ip),
         salida_valida(datos->dns_inverso),
         salida_valida(datos->navegador)
         );

  printf("</td></tr></table>\n"
         "</center>\n"
         );
}

void salida_conexiones_html(t_salida_conexiones *datos)
{
t_caller_id *telef;
long ultima_conexion;
long ultimo_tiempo;
int causa_desconexion;

  if(datos==NULL) {
    printf("<center><h2>Usted no es usuario de ARGO</h2>"
           "<font size=+1><b><i>El sistema no le reconoce como un usuario "
           "de este proveedor. Si usted es realmente un abonado "
           "de ARGO, el problema es que est&aacute; accediendo "
           "a este servicio de informaci&oacute;n a trav&eacute;s "
           "de una red externa. Este servicio solo est&aacute; "
           "disponible si accede desde su conexi&oacute;n ARGO "
           "</i></b></font></center>\n");
    return;
  }

  ultima_conexion=datos->ultima_conexion;
  ultimo_tiempo=datos->ultimo_tiempo;

  if(ultima_conexion>ultimo_tiempo) ultima_conexion-=ultimo_tiempo;

  causa_desconexion=datos->causa_desconexion;

  if(datos->login==NULL) {
    printf("<center><h2>No se ha podido encontrar "
           "informaci&oacute;n sobre esta "
           "conexi&oacute;n</h2></center>\n");
    return;
  }

  if(datos->anteriores_flag) {
    lista_antiguo(datos->login);
    return;
  }

  printf("<center><br><h2>Los siguientes datos no tienen en cuenta la "
         "conexi&oacute;n actual</h2></center>\n"
         "<!mensual>\n"
         "<p><center><table width=100%%>\n"
         "<tr><td width=49%% valign=top align=right>\n"
         "<!mensual>\n"
         "Login<p>\n"
         "Nombre de Usuario<p>\n"
         "<!mensual>\n"
         "N&uacute;mero de llamadas en este mes<p>\n"
         "Tiempo de conexi&oacute;n en este mes<p>\n"
         "Causa de la &uacute;ltima desconexi&oacute;n<p><br><br>\n"
         "Tel&eacute;fonos desde los que se ha llamado<p>\n"
         "</td><td width=2%%></td><td valign=top>\n"
         );
  printf("<!mensual>\n%s<p>\n",datos->login);
  printf("%s<p>\n",salida_valida(datos->nombre));
  printf("<!mensual>\n%ld<p>\n",datos->num_conexiones);
  printf("%ld Horas, %ld Minutos y %ld Segundos<p>\n",
         datos->tiempo/3600,(datos->tiempo%3600)/60,
         datos->tiempo%60);
  printf("%d (",causa_desconexion);
  switch(causa_desconexion) {
  case 0: printf("--"); /* printf("No hay conexiones previas"); */ break;

/* Desconexiones ASCEND */
  case 1010: printf("Portadora no detectada"); break;
  case 1011:
  case 1185: printf("P&eacute;rdida de portadora"); break;
  case 1021: printf("TimeOut por inactividad"); break;
  case 1042: printf("Clave erronea o demasiadas sesiones"); break;
  case 1020:
  case 1045: printf("Desconexi&oacute;n normal"); break;
  case 1047: printf("Cierre LCP antes de abrir NCP's"); break;
  case 1100: printf("Tiempo de conexi&oacute;n excedido"); break;

/* Desconexiones estandar */
  case 1: printf("Desconexi&oacute;n normal"); break;
  case 2: printf("P&eacute;rdida de portadora"); break;
  case 3: printf("Sin Servicio"); break;
  case 4: printf("TimeOut por inactividad"); break;
  case 5: printf("Tiempo de conexi&oacute;n excedido"); break;
  case 6: printf("Reset Administrativo"); break;
  case 7: printf("Reinicio Administrativo"); break;
  case 8: printf("Error de Puerto"); break;
  case 9: printf("Error de NAS"); break;
  case 10: printf("Solicitado por el NAS"); break;
  case 11: printf("NAS Reiniciado"); break;
  case 12: printf("Puerto no finalizado"); break;
  case 13: printf("Puerto Preempted"); break;
  case 14: printf("Puerto Suspendido"); break;
  case 15: printf("Servicio No Disponible"); break;
  case 16: printf("CallBack"); break;
  case 17: printf("User Error"); break;
  case 18: printf("Host Request"); break;

  default: printf("Raz&oacute;n desconocida. "
                  "<a href=mailto:ayuda@argo.es>"
                  "Comunicar a ARGO</a>."); break;
  }
  printf(")<br>\n%s<br>\n(%ld Horas, %ld Minutos y %ld Segundos)<p>\n",
         !ultima_conexion ? "" : ctime(&ultima_conexion),
          ultimo_tiempo/3600,(ultimo_tiempo%3600)/60,
          ultimo_tiempo%60);
  telef=datos->numero;
  while(telef!=NULL)
  {
    if(*telef->numero=='\0')
      printf("Central Anal&oacute;gica ");
    else {
      printf("%s ",telef->numero);
    }

    printf("(%ld conexiones - %ldh, "
           "%ldmin y %ldseg)<br>\n",
           telef->num_conexiones,
           telef->tiempo/3600,
           (telef->tiempo%3600)/60,
           telef->tiempo%60);
    telef=telef->siguiente;
  }
  printf("</table><p><table width=100%%>\n"
         "<tr><td width=49%% align=right>\n"
         "Bytes enviados<br>\n"
         "Bytes recibidos<p>\n"
         "</td><td width=2%%></td>"
         "<td>\n"
         "%lld<br>%lld<p>",datos->bytes_tx,datos->bytes_rx
         );
  printf("</td></tr><tr><td width=49%% align=right>"
         "Paquetes IP enviados<br>\n"
         "Paquetes IP recibidos<p>\n"
         "</td><td width=2%%>"
         "</td><td>\n"
         "%lld<br>%lld<p>\n",
         datos->paquetes_tx,datos->paquetes_rx
         );

  printf("</td></tr></table>\n"
         "</center>\n"
         );

  printf("<!mensual>\n");

  if(*(datos->ip)) {
  char *fecha=ctime(&(datos->fecha));

    *(fecha+24)='\0';
    printf("<br><center><b><font size=+2>Direcci&oacute;n "
           "IP actual: %s</font></b>\n<br>(%s)</center><p>\n",
           datos->ip,fecha);
  } else {
    printf("<center><h2>Este usuario no "
           "est&aacute; conectado en "
           "este momento"
           "</h2></center>\n");
  }

  if(datos->query_string==NULL) datos->query_string="";
  printf("<center><a href=/cgi-bin/conexiones?%s*>"
         "Archivo hist&oacute;rico</a></center>\n",datos->query_string);
}


