/*
** UTIL.C
**
** Rutinas existentes en las librerias
** estandar, pero que se incluyen aqui
** por ser mas eficientes, entre otras
** cosas por el inlining.
**
**
** (c) 1.997-99 Jesus Cea Avion
** jcea@argo.es
** http://www.argo.es/~jcea/
** http://www.argo.es/~jcea/artic/radius02.htm
**
** Lea las condiciones de uso y distribucion
** en el fichero "COPYING".
**
**
** 20/Oct/98 La definicion de una nueva rutina "strchr"
**           aporta una mejora del 10%.
**           Una nueva rutina "strcmp" mejora el
**           rendimiento un 17% adicional.
**
** 07/Nov/98 Hago cambios para evitar los warnings.
*/

#include <string.h>
#include "util.h"

/*
** los punteros, en el prototipo original, usan el modificador "const".
** Aqui no lo hacemos para evitar warnings.
** Adicionalmente se anade el "unsigned".
*/

unsigned char *strchr_jcea(unsigned char *s,int c)
{
unsigned char *p=s; /* Unsigned porque mejora rendimiento */
unsigned char cc=c;

  while((*p)&&(*p!=cc)) p++;
  if(*p) return p;
  else return NULL;
}

int strcmp_jcea(unsigned char *s1,unsigned char *s2)
{
unsigned char *p1=s1,*p2=s2; /* Unsigned porque mejora rendimiento */
int d;
unsigned char c;

  do {
    c=*p1++;
    d=c-(*p2++);
  } while((!d)&&(c));
  return d;
}

